{$G+,N+}                                                { 286+, 287+ }
{$R-,S-}
Unit Misc;

Interface

{$I CONSTS.PAS}

Function BIOS_Time : LongInt;
Procedure PutPixel2 (X, Y : Integer; C : Byte);
Procedure Line2 (X1, Y1, X2, Y2 : Integer; C : Byte);


Implementation

Uses Grafix;

Function BIOS_Time : LongInt;
Begin
  BIOS_Time := MemL[Seg0040:$6C]
End;

Procedure PutPixel2 (X, Y : Integer; C : Byte);
Begin
  If (X >= 0) and (X < Screen_Width) and
     (Y >= 0) and (Y < Screen_Height) then
    PutPixel (X, Y, C)
End;

Function Sgn (I : Integer) : Integer; Assembler;
Asm
  Mov   AX, I
  Or    AX, AX
  JZ    @end
  ShL   AX, 1
  JC    @1
  Mov   AX, 1
  Jmp   @end
@1:
  Mov   AX, -1
@end:
End;

Function _Abs (I : Integer) : Integer; Assembler;
Asm
  Mov   AX, I
  Test  AX, 8000h
  JZ    @end
  Neg   AX
@end:
End;

Procedure Line2 (X1, Y1, X2, Y2 : Integer; C : Byte);
Var
  SX, SY, M, N,
  DX1, DY1, DX2, DY2, Cnt, K : Integer;
Begin
  SX := X2-X1;
  SY := Y2-Y1;
  DX1 := Sgn (SX);
  DY1 := Sgn (SY);
  M := _Abs (SX);
  N := _Abs (SY);
  DX2 := DX1;
  DY2 := 0;
  If M < N then
    Begin
      M := _Abs (SY);
      N := _Abs (SX);
      DX2 := 0;
      DY2 := DY1
    End;
  Cnt := M+1;
  K := 0;
  Repeat
    If (X1 >= 0) and (X1 < Screen_Width) and
       (Y1 >= 0) and (Y1 < Screen_Height) then
      PutPixel (X1, Y1, C);
    Inc (K, N);
    If K < M then Begin
      Inc (X1, DX2);
      Inc (Y1, DY2)
    End
    Else Begin
      Dec (K, M);
      Inc (X1, DX1);
      Inc (Y1, DY1)
    End;
    Dec (Cnt)
  Until Cnt = 0
End;

End.
